/* OS- and machine-dependent stuff for IBM-PC running MS-DOS
 * Copyright 1991 Phil Karn, KA9Q
 * Mods by KO4KS
 */
#ifdef MSDOS
#include <conio.h>
#include "global.h"
#include "commands.h"
#include <dir.h>
#include <dos.h>
#include <sys/stat.h>
#include <string.h>
#include <process.h>
#include <fcntl.h>
/*#include <alloc.h> */
#include <stdarg.h>
#include <bios.h>
#include <time.h>
#include <dpmi.h>
#include <signal.h>
#include <crt0.h>
#include "mbuf.h"
#include "proc.h"
#include "iface.h"
#include "internet.h"
#include "session.h"
#include "socket.h"
#include "usock.h"
#include "cmdparse.h"
#include "nospc.h"
/* #include "display.h" */
#include "tty.h"

#if !defined(_lint)
static char rcsid[] OPTIONAL = "$Id: pc.c,v 1.17 1996/09/20 12:27:08 root Exp root $";
#endif

#define FP_OFF( fp )( (unsigned )( fp ))
unsigned Nfiles = 128;

#ifdef XSPAWN
#include "xspawn.h"
static int Xspawn = 1;
#define SPAWNVP xspawnvp
#else
#define SPAWNVP spawnvp
#endif

#if 0
static void statline(struct display *dp,struct session *sp);
#endif
void fcloseall (void);

int _go32_dpmi_unchain_protected_mode_interrupt_vector(uint irq,_go32_dpmi_seginfo *info);
void eoi(void);

extern int Curdisp;
extern struct proc *Display;
volatile int Tick;
volatile int32 Clock;

static int saved_break;

/* Keyboard input buffer */
#define	KBSIZE	256
static struct {
	char buf[KBSIZE];
	char *wp;
	char *rp;
	int cnt;
} Keyboard;


struct int_tab {
	__dpmi_paddr old;	/* Previous handler at this vector */
	_go32_dpmi_seginfo new;	/* Current handler, with wrapper info */
	void (*func)(int);	/* Function to call on interrupt */
	int arg;		/* Arg to pass to interrupt function */
	int chain;		/* Is interrupt chained to old handler? */
} Int_tab[16];


int Watchdog = 0;			/* Watch Dog off by default */
int WDTick = 300*(1000 / MSPTICK);	/* 5 minutes watchdog timer */
int WDCurr = 300*(1000 / MSPTICK);	/* Initial count down timer */

static const char DFAR wdogstr[] = "NOS Watch Dog";
static const char DFAR fkeysyntax1[] =
	"key   num    key    num    key    num    key    num   key    num\n"
	"f1     59    sf1     84    cf1     94    af1    104   pgup    73\n"
	"f2     60    sf2     85    cf2     95    af2    105   pgdn    81\n";
static const char DFAR fkeysyntax2[] =
	"f3     61    sf3     86    cf3     96    af3    106   home    71\n"
	"f4     62    sf4     87    cf4     97    af4    107   end     79\n"
	"f5     63    sf5     88    cf5     98    af5    108   arup    72\n";
static const char DFAR fkeysyntax3[] =
	"f6     64    sf6     89    cf6     99    af6    109   ardn    80\n"
	"f7     65    sf7     90    cf7    100    af7    110   ar l    75\n"
	"f8     66    sf8     91    cf8    101    af8    111   ar r    77\n";
static const char DFAR fkeysyntax4[] =
	"f9     67    sf9     92    cf9    102    af9    112   ins     82\n"
	"f10    68    sf10    93    cf10   103    af10   113   del     83\n"
	"f11   133    sf11   135    cf11   137    af11   139   stab    15\n";
static const char DFAR fkeysyntax5[] =
	"f12   134    sf12   136    cf12   138    af12   140   cprtsc 114\n"
	"cpgup 132    cpgdn  118    chome  119    cend   117\n"
	"usage: fkey <key number> [<value> | \"string\"]\n";

static const char DFAR fkeyoor[] = "fkey number out of range.\n";
static const char DFAR fkeynf[] = "fkey number not found\n";
static const char DFAR fkeynoval[] = "fkey %d has no assigned value.\n";
static const char DFAR noprompt[] = "\b\b\b\b\b\b\b\b        \b\b\b\b\b\b\b\b";
static const char DFAR somemore[] = "--More--";
static const char DFAR isatstr[] = "AT/386 mode";

FILE *Rawterm;
int Isat;
static char Ttbuf[BUFSIZ];


/* Called at startup time to set up misc I/O related functions */
void
ioinit(int hinit)
{
	union REGS inregs;
	extern int _fmode;

	_fmode = O_BINARY;
	/* Get some memory on the heap so interrupt calls to malloc
	 * won't fail unnecessarily
	 */
	free(malloc(hinit));

	Rawterm = fopen("con","wb");
	setbuf(Rawterm,Ttbuf);

	/* Increase the size of the file table.
	 * Note: this causes MS-DOS
	 * to allocate a block of memory to hold the larger file table.
	 * By default, this happens right after our program, which means
	 * any further sbrk() calls from morecore (called from malloc)
	 * will fail. Hence there is now code in alloc.c that can call
	 * the MS-DOS allocmem() function to grab additional MS-DOS
	 * memory blocks that are not contiguous with the program and
	 * put them on the heap.
	 */
	inregs.h.ah = 0x67;
	inregs.x.bx = Nfiles;	/* Up to the base of the socket numbers */
	intdos(&inregs,&inregs);	

	saved_break = getcbrk();
	setcbrk(0);
	signal(SIGINT,SIG_IGN);

	/* Chain protected mode keyboard interrupt */
	setvect(1,1,kbint,0);

	/* Chain timer interrupt */
	setvect(0,1,ctick,0);
}
/* Called just before exiting to restore console state */
void
iostop(void)
{
	struct iface *ifp,*iftmp;
	void (**fp)(void);

	setbuf(Rawterm,NULLCHAR);
	setcbrk(saved_break);

	for(ifp = Ifaces;ifp != NULL;ifp = iftmp){
		iftmp = ifp->next;
		if_detach(ifp);
	}
	/* Call list of shutdown functions */
	for(fp = Shutdown;*fp != NULL;fp++){
		(**fp)();
	}
	fcloseall();
	/* Restore previous timer and keyboard interrupts */
	freevect(0);
	freevect(1);
}

#ifdef SHELL
/* Spawn subshell */
int
doshell(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	char *command;
	int ret;

#ifdef MULTITASK
	if(Background) {
		if(!start_back())
			return -1;
		Nokeys++;
	}
	free(mallocw(Minheap)); /* Force heap/core break to reserve a heap */
#endif

	if(argc == 1 || !stricmp(argv[1], "/c")) {
		if((command = getenv("COMSPEC")) == NULLCHAR)
			command = "COMMAND.COM";
#ifdef XSPAWN
		if (!Xspawn)
			ret = spawnvp(P_WAIT,command,argv);
		else
#endif
	 		ret = SPAWNVP(P_WAIT,command,argv);
	} else {
#ifdef XSPAWN
		if (!Xspawn)
			ret = spawnvp(P_WAIT,argv[1],(argv + 1));
		else
#endif
			ret = SPAWNVP(P_WAIT,argv[1],(argv + 1));
	}

#ifdef MULTITASK
	if(Background) {
		Nokeys--;
		stop_back();
	}
#endif

	return ret;
}
#endif

#ifdef ALLCMD
/* Spawn mailer as subshell */
int
dobmail(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	char *command;
	int ret;

#ifdef MULTITASK
	if(Background) {
		if(!start_back())
			return -1;
		Nokeys++;
	}
	free(mallocw(Minheap));
#endif

	if((command = getenv("MAILER")) == NULLCHAR)
		command = "BM.EXE";
#ifdef XSPAWN
	if (!Xspawn)
		ret = spawnvp(P_WAIT,command,argv);
	else
#endif
		ret = SPAWNVP(P_WAIT,command,argv);

#ifdef MULTITASK
	if(Background) {
		Nokeys--;
		stop_back();
	}
#endif

	smtptick(NULL);		/* tickle smtp to send any mail */
	return ret;
}
#endif /*ALLCMD*/

#ifdef MULTITASK
/* if multitask mode is set - allow NOS and shell/mail to share system time */
dobackg(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return setbool(&Background,backgstr,argc,argv);
}
#endif

/* if watch-dog mode is set - make NOS reboot the system if it stalls */
dowatchdog(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return setbool(&Watchdog,wdogstr,argc,argv);
}

#ifdef XSPAWN
doxspawn(argc,argv,p)
int argc;
char *argv[];
void *p;
{
int retval;

	retval = setbool(&Xspawn,XSPAWNmode,argc,argv);
	_swap = (Xspawn ^ 1);
	return retval;
}
#endif

static int
kbchar()
{
int c;
#if 1
	while((c = kbraw()) == 0)
		pwait(&kbint);
#else
	do	{
		c = kbraw();
		if (c == 0)
			pwait(&kbint);
	} while (c == 0);
#endif
	return (c);
}
/* Flush the raw terminal output */
void
rflush()
{
	fflush(Rawterm);
}

#ifdef MSDOS
#ifdef ALLCMD
struct funcstr {
	unsigned char fkey;
	char alloced;
	char *fvalue;
};

struct funcstr DFAR fkeys[] = {
	15,0,NULLCHAR,	/* tab + shift */
	59,1,NULLCHAR,  /* F1 */
	60,1,NULLCHAR,  /* F2 */
	61,1,NULLCHAR,  /* F3 */
	62,1,NULLCHAR,  /* F4 */
	63,0,NULLCHAR,	/* F5 */
	64,0,NULLCHAR,	/* F6 */
	65,0,NULLCHAR,	/* F7 */
	66,0,NULLCHAR,	/* F8 */
	67,0,NULLCHAR,	/* F9 */
	68,0,NULLCHAR,	/* F10 */
	71,1,NULLCHAR,	/* home*/
	72,1,"\033[A",	/* up arrow*/
	73,1,NULLCHAR,	/* pgup */
	75,1,"\033[D",	/* left arrow */
	77,1,"\033[C",	/* right arrow */
	79,1,NULLCHAR,	/* end */
	80,1,"\033[B",	/* down arrow */
	81,1,NULLCHAR,	/* pgdn */
	82,1,NULLCHAR,	/* ins */
	83,1,NULLCHAR,	/* del */
	84,0,NULLCHAR,	/* F1 + shift*/
	85,0,NULLCHAR,	/* F2 + shift*/
	86,0,NULLCHAR,	/* F3 + shift*/
	87,0,NULLCHAR,	/* F4 + shift*/
	88,0,NULLCHAR,	/* F5 + shift*/
	89,0,NULLCHAR,	/* F6 + shift*/
	90,0,NULLCHAR,	/* F7 + shift*/
	91,0,NULLCHAR,	/* F8 + shift*/
	92,0,NULLCHAR,	/* F9 + shift*/
	93,0,NULLCHAR,	/* F10 + shift*/
	94,0,NULLCHAR,	/* F1 + control*/
	95,0,NULLCHAR,	/* F2 + control*/
	96,0,NULLCHAR,	/* F3 + control*/
	97,0,NULLCHAR,	/* F4 + control*/
	98,0,NULLCHAR,	/* F5 + control*/
	99,0,NULLCHAR,	/* F6 + control*/
	100,0,NULLCHAR,	/* F7 + control*/
	101,0,NULLCHAR,	/* F8 + control*/
	102,0,NULLCHAR,	/* F9 + control*/
	103,0,NULLCHAR,	/* F10 + control*/
	104,0,NULLCHAR,	/* F1 + alt*/
	105,0,NULLCHAR,	/* F2 + alt*/
	106,0,NULLCHAR,	/* F3 + alt*/
	107,0,NULLCHAR,	/* F4 + alt*/
	108,0,NULLCHAR,	/* F5 + alt*/
	109,0,NULLCHAR,	/* F6 + alt*/
	110,0,NULLCHAR,	/* F7 + alt*/
	111,0,NULLCHAR,	/* F8 + alt*/
	112,0,NULLCHAR,	/* F9 + alt*/
	113,0,NULLCHAR,	/* F10 + alt*/
	114,0,NULLCHAR,	/* PrtSc + ctl*/
	117,0,NULLCHAR,	/* end  + ctl */
	118,0,NULLCHAR,	/* pgup + ctl */
	119,0,NULLCHAR,	/* home + ctl */
	132,0,NULLCHAR,	/* pgdn + ctl */
	133,0,NULLCHAR, /* F11 */
	134,0,NULLCHAR, /* F12 */
	135,0,NULLCHAR, /* F11 + shift */
	136,0,NULLCHAR, /* F12 + shift */
	137,0,NULLCHAR, /* F11 + control */
	138,0,NULLCHAR, /* F11 + control */
	139,0,NULLCHAR, /* F11 + alt */
	140,0,NULLCHAR, /* F11 + alt */
	  0,0,NULLCHAR
};

char Leftover = 0;
char *Nextkey;
#endif /*ALLCMD*/
#endif /*MSDOS*/

/* Read characters from the keyboard, translating them to "real" ASCII.
 * If none are ready, block. The F-10 key is special; translate it to -2.
 */
#ifdef ALLCMD
int
kbread()
{
	int c,i,j;

	if((c = Leftover) != 0)  {
		Leftover = *Nextkey++;
		return c;
	}
#if 1
	c = kbchar();
	if ((c & 0xff) == 0){
#else
	if((c = kbchar()) & 0xff == 0){
#endif
		/* Lead-in to a special char */
		c = (c >> 8) & 0xff;
		switch(c){
		case 3:		/* NULL (bizzare!) */
			c = 0;
			break;
	case 72:    /* UP ARROW key (used as previous history command) */
			if(Current == Command) {   
				c = UPARROW;
				break;
			}
			goto all;
	case 80:    /* DOWN ARROW key (used as next history command) */
			if(Current == Command) {
				c = DNARROW;
				break;
			}
			goto all;
        case 68:    /* F-10 key (used as command-mode escape) */
			if(fkeys[10].fvalue == NULLCHAR){
				c = -2;
				break;
			}
		        goto all;
        case 82:   /* INSERT key (used as status line toggle) */
			if(fkeys[19].fvalue == NULLCHAR){
				c = -105;
				break;
			}
			goto all;
        case 83:   /* DELETE key (used as flow mode toggle) */
			if(fkeys[20].fvalue == NULLCHAR){
				c = -106;
				break;
			}
			goto all;
        case 71:   /* HOME key (used to kick this session) */
			if(fkeys[11].fvalue == NULLCHAR){
				c = -107;
				break;
			}
			goto all;
        case 79:   /* END key (used to kill this session) */
			if(fkeys[16].fvalue == NULLCHAR){
				c = -108;
				break;
			}
			goto all;
        case 73:   /* PGUP key (used to toggle to previous session) */
			if(fkeys[13].fvalue == NULLCHAR){
				c = -109;
				break;
			}
			goto all;
        case 81:   /* PGDN key (used to toggle to next session) */
			if(fkeys[18].fvalue == NULLCHAR){
				c = -110;
				break;
			}
			goto all;
        default:    /* Dunno what it is */
all:
            if(c > 58 && c < 68) {  /* F1 to F9 */
                if(fkeys[c-58].fvalue == NULLCHAR) {
                    c = (c - 56) * -1; /* NO fkey defined - WG7J */
                    break;
                }
            }
            for(i=0;(j = fkeys[i].fkey) != 0;i++)
				if(j == c) {
					Nextkey = fkeys[i].fvalue;
					if(Nextkey == NULLCHAR) {
						c = -1;
						return c;
					}
					/* If first char of fvalue is '~'
					 * switch to command session.
					 */
					if((c = *Nextkey++) == '~') {
						c = -2;
						Leftover = *Nextkey++;
					} else {
						if(c != 0)
							Leftover = *Nextkey++;
						else
							c = -1;
					}
					return c;
				}
			c = -1;
		}
	} else
		c = c & 0xff;
	return c;
}
#else /*ALLCMD*/

int
kbread()
{
        int c;

        if((c = kbchar()) == 0){
                /* Lead-in to a special char */
                c = kbchar();
                if(Current == Command) {    /* Check for command recall */
                    if(c == 72)     /* UP arrow */
                        return UPARROW;
                    if(c == 80)     /* DOWN arrow */
                        return DNARROW;
                }
                switch(c){
                case 3:         /* NULL (bizzare!) */
                        c = 0;
                        break;
                case 68:        /* F-10 key (used as command-mode escape) */
                        c = -2;
                        break;
                case 83:        /* DEL key */
                        c = 0x7f;
                        break;
                default:        /* Dunno what it is */
                    if(c > 58 && c < 68)    /* F1 to F9 */
                        c = (c - 56) * -1;
                    else
                        c = -1;
                }
        }
        return c;
}

#endif /*ALLCMD*/

#ifdef	MSDOS
#ifdef ALLCMD
int
dofkey(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	int c,i,j;
	char *q, *r;
	char str[100];

	if(argc == 1) {
	   tputs(fkeysyntax1);
	   tputs(fkeysyntax2);
	   tputs(fkeysyntax3);
	   tputs(fkeysyntax4);
	   tputs(fkeysyntax5);
	   return 0;
	}

	c = atoi(argv[1]);
	if(c == 0 || c > 255) {
		tputs(fkeyoor);
		return 1;
	}

	for(j = 0;(i = fkeys[j].fkey) != 0; j++)
		if(i == c) 
			break;

	if(i == 0){
		tputs(fkeynf);
		return 1;
	}

	if(argc == 2) {
		q = fkeys[j].fvalue;
		r = str;
		if(q == NULLCHAR)
			tprintf(fkeynoval,c);
		else {
			while(*q)
				if(*q < ' ') { /* This is ASCII dependent !! */
					*r++ = '^';
					*r++ = *q++ + 0x40;
				} else
					*r++ = *q++;
			*r = '\0';
			tprintf("fkey = %s\n",str);
		}
		return 0;
	}

	if(argc == 3) {
		if(fkeys[j].alloced)
			fkeys[j].alloced = 0;
		else
			if(fkeys[j].fvalue != NULLCHAR)
				free(fkeys[j].fvalue);

		r = str;
		q = argv[2];
		while(*q){
			if(*q == '^'){	/* ^ gives control char next */
				q++;
				if(*q == '^') {
					*r++ = *q++; /* No, he wants a ^ */
				} else {
					*r++ = *q++ & 0x1f;
				}
			} else
				*r++ = *q++;
		}
		*r = '\0';
		fkeys[j].fvalue = strdup(str);
	}
	return 0;
}
#endif /*ALLCMD*/
#endif /*MSDOS*/

/* Disable hardware interrupt */
int
maskoff(uint irq)
{
	if(irq < 8){
		setbit(0x21,(char)(1<<irq));
	} else if(irq < 16){
		irq -= 8;
		setbit(0xa1,(char)(1<<irq));
	} else {
		return -1;
	}
	return 0;
}
/* Enable hardware interrupt */
int
maskon(uint irq)
 {
	if(irq < 8){
		clrbit(0x21,1<<irq);
	} else if(irq < 16){
		irq -= 8;
		clrbit(0xa1,1<<irq);
	} else {
		return -1;
	}
	return 0;
}
/* Return 1 if specified interrupt is enabled, 0 if not, -1 if invalid */
int
getmask(unsigned irq)
{
	if(irq < 8)
		return (inportb(0x21) & (1 << irq)) ? 0 : 1;
	else if(irq < 16){
		irq -= 8;
		return (inportb(0xa1) & (1 << irq)) ? 0 : 1;
	} else
		return -1;
}
/* Called from assembler stub linked to BIOS interrupt 1C, called on each
 * hardware clock tick. Signal a clock tick to the timer process.
 */
void
ctick(void)
{
	if(Watchdog)
		if(WDCurr-- == 0)
			sysreset();	
	Tick++;
#if 1	/* def notdef */
	Clock++;	/* Keep system time */
#endif
	psignal((void *)&Tick,1);
}
/* Read the Clock global variable, with interrupts off to avoid possible
 * inconsistency on 16-bit machines
 */
int32
rdclock(void)
{
	int i_state;
	int32 rval;

	i_state = disable();
	rval = Clock;
	restore(i_state);
	return rval;
}

/* Called from the timer process on every tick. NOTE! This function
 * can NOT be called at interrupt time because it calls the BIOS
 */
void
pctick(void)
{
	long t;
	static long oldt;	/* Value of bioscnt() on last call */

	/* Check for day change */
	t = bioscnt();
	if(t < oldt){
		/* Call the regular DOS time func to handle the midnight flag */
		(void)time(NULL);
	}
}

/* Set bit(s) in I/O port */
void
setbit(uint port,uint8 bits)
{
	outportb(port,inportb(port)|bits);
}
/* Clear bit(s) in I/O port */
void
clrbit(uint port,uint8 bits)
{
	outportb(port,inportb(port) & ~bits);
}
/* Set or clear selected bits(s) in I/O port */
void
writebit(
uint port,
uint8 mask,
int val
){
	uint8 x;

	x = inportb(port);
	if(val)
		x |= mask;
	else
		x &= ~mask;
	outportb(port,x);
}

#if 0
void
display(int i,void *v1,void *v2)
{
	struct session *sp;
	struct display *dp;
	static struct display *lastdp;
	static long lastkdebug;

	for(;;){
		sp = Current;
		if(sp == NULL || sp->output == NULL
#if 0
		 || (dp = (struct display *)sp->output->ptr) == NULL
#endif
		 ){
			/* Something weird happened */
			mspause(500L);
			continue;
		}
		if(dp != lastdp
#if 0
		 || Kdebug != lastkdebug
#endif
		 )
			dp->flags.dirty_screen = 1;
		statline(dp,sp);
		dupdate(dp);
		lastdp = dp;
#if 0
		lastkdebug = Kdebug;
#endif
		alarm(100L);	/* Poll status every 100 ms */
		pwait(dp);
		alarm(0L);
	}
}

/* Compose status line for bottom of screen */
static void
statline(struct display *dp,struct session *sp)
{
	int attr;
	char buf[81];
	struct text_info text_info;
	int unack;
	int s1;
	int s = -1;

	/* Determine attribute to use */
	gettextinfo(&text_info);
	if(text_info.currmode == MONO)
		attr = 0x07;	/* Regular white on black */
	else
		attr = 0x02;	/* Green on black */

#if 0
	if(sp->network != NULL && (s = fileno(sp->network)) != -1){
		unack = socklen(s,1);
		if(sp->type == FTP && (s1 = fileno(sp->cb.ftp->data)) != -1)
			unack += socklen(s1,1);
	}
#endif
	memset(buf,' ',80);
	buf[80] = '\0';
	sprintf(&buf[0],"%2d: %s",sp->index,sp->name);

	if(dp->flags.scrollbk){
		int off;
		off = dp->virttop - dp->realtop;
		if(off < 0)
			off += dp->size;
		sprintf(&buf[54],"Scroll:%-5u",off);
	} else if(s != -1 && unack != 0){
		sprintf(&buf[54],"Unack: %-5u",unack);
	} else
		sprintf(&buf[54],"            ");
	sprintf(&buf[66],"F8:nxt F10:cmd");
	statwrite(0,buf,sizeof(buf)-1,attr);
}
void
swapscreen(old,new)
struct session *old,*new;
{
}
void
freescreen(sp)
struct session *sp;
{
}
void
newscreen(sp)
struct session *sp;
{
	newdisplay (0, 0, 1, 1000);
}
#else
void stowit (size_t index, int save, unsigned char attr);
extern unsigned char SCREENwidth, SCREENlength;
extern int STATLINE;
extern struct session *ScreenOwner;		/* Session currently displayed */

void
newscreen(sp)
struct session *sp;
{
	if(sp != NULLSESSION)	{
		sp->screen = callocw(1,sizeof(struct screen));
		sp->screen->statline = STATLINE;
	}
}
void
freescreen(sp)
struct session *sp;
{
	if(sp == NULLSESSION || sp->screen == NULLSCREEN)
		return;
	if((sp->screen->save != NULLCHAR) && sp->screen->save != (char *) 1)
		free(sp->screen->save);
	free((char *)sp->screen);
}


/* Save specified session screen and resume console screen */
void
swapscreen(old,new)
struct session *old,*new;
{
struct text_info tr;
unsigned char attr;
	
	if(old == new)
		return;	/* Nothing to do */

	fflush(Rawterm);
	gettextinfo(&tr);
	if(old != NULLSESSION){
		/* Save old screen */
		if(old->screen->save == NULLCHAR)
			old->screen->save = (char *) 1;
#if 0
		old->screen->row = tr.cury;
		old->screen->col = tr.curx;
#else
		old->screen->row = wherey();
		old->screen->col = wherex();
#endif
		old->screen->attr = tr.attribute;

		if(old->screen->save != NULLCHAR){
			if(old->split){
				window(1,1,SCREENwidth,SCREENlength);
				tr.winbottom = SCREENlength;
			}
			stowit(old->index, 1, 0);	// save it
		}
	}
	if(new != NULLSESSION){
		/* Load new screen */
		if(new->screen->save != NULLCHAR){
			if(new->split)
				window(1,1,SCREENwidth,SCREENlength - 2);
			else
				window(1,1,SCREENwidth,SCREENlength);

			setscreens ((new->screen->attr >> 4) & 0x07, new->screen->attr & 0x0f, 0);
			stowit (new->index, 0, new->screen->attr);	// retrieve it
			new->screen->attr &= 0x7f;	// remove color change bit

//			if (STATLINE && (Current == Command))
				window (1,1 + new->screen->statline,SCREENwidth,SCREENlength - (new->split * 2));
			gotoxy(new->screen->col,new->screen->row);
			textattr (new->screen->attr);
			new->screen->save = NULLCHAR;
		} else {
			window(1,1,SCREENwidth,SCREENlength);
			clrscr();	/* Start with a fresh slate */
			if(new->split){
				new->tsavex = 1;
				new->tsavey = 1;
				new->bsavex = 1;
				new->bsavey = SCREENlength - 1;
				window(1,SCREENlength - 1,SCREENwidth,SCREENlength);
				gettextinfo(&tr);
				attr = ((tr.attribute & 0x0f) << 4) + ((tr.attribute & 0x70) >> 4);
				textattr (attr);
				clrscr ();
				cputs("_\b");
				window(1,1 + new->screen->statline,SCREENwidth,SCREENlength - 2 - new->screen->statline);
				textattr (tr.attribute);
				}
			else
				window(1,1 + new->screen->statline,SCREENwidth,SCREENlength - new->screen->statline);
//			if (STATLINE)
//				displayStatLine (-1);
		}
	}
	ScreenOwner = new;
	displayStatLine (0, 1);
	alert(Display,1);	/* Wake him up */
}

void
display(i,v1,v2)
int i;
void *v1;
void *v2;
{
	int c;
	struct session *sp;

	/* This is very tricky code. Because the value of "Current" can
	 * change any time we do a pwait, we have to be careful to detect
	 * any change and go back and start again.
	 */
	for(;;){
		sp = Current;

		if(sp->morewait){
			pwait(&sp->row);
			if(sp != Current || sp->row <= 0){
				/* Current changed value, or the user
				 * hasn't really hit a key
				 */
				continue;
			}
			/* Erase the prompt */
			cprintf(noprompt);
			rflush ();
		}
		sp->morewait = 0;
		if((c = rrecvchar(sp->output)) == EOF){
			/* the alert() in swapscreen will cause this to
			 * return EOF when current changes
			 */
			pwait(NULL);	/* Prevent a nasty loop */
			continue;
		}
#ifdef SCREENSAVER
		sskick ();
#endif
		if(sp->split){
			if(c == 0x0a){
				cputs(Eol);
				clreol();
			} else
				putch(c);
		} else {
			cprintf("%c", c);
		}
        /* Fix by Ron Murray, vk6zjm */
        if(sp->record != NULLFILE)      /* Don't save CR if ascii mode */
            if (c != '\r' || sockmode(sp->output, -1) != SOCK_ASCII)
                putc(c,sp->record);
#ifdef notdef
        if(sp->record != NULLFILE)
			putc(c,sp->record);
#endif
        if(sp->flowmode && c == '\n' && --sp->row <= 0){
			cprintf(somemore);
			sp->morewait = 1;
		}
	}
}

#endif

/* Return time since startup in milliseconds. Resolution is improved
 * below 55 ms (the clock tick interval) by reading back the instantaneous
 * 8254 counter value and combining it with the global clock tick counter.
 *
 * Reading the 8254 is a bit tricky since a tick could occur asynchronously
 * between the two reads. The tick counter is examined before and after the
 * hardware counter is read. If the tick counter changes, try again.
 * Note: the hardware counter counts down from 65536.
 */
int32
msclock(void)
{
	int32 hi;
	uint lo;
	uint64 x;

	do {
		hi = rdclock();
		lo = clockbits();
	} while(hi != rdclock());

	x = ((uint64)hi << 16) - lo;
	return (x * 11) / 13125;
}
/* Return clock in seconds */
int32
secclock(void)
{
	int32 hi;
	uint lo;
	uint64 x;

	do {
		hi = rdclock();
		lo = clockbits();
	} while(hi != rdclock());

	x = ((uint64)hi << 16) - lo;
	return (x * 11) / 13125000;
}

int
doisat(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return setbool(&Isat,isatstr,argc,argv);
}

/* Return time in raw clock counts, approx 838 ns */
int32
usclock(void)
{
	int32 hi;
	uint lo;

	do {
		hi = rdclock();
		lo = clockbits();
	} while(hi != rdclock());

	return (hi << 16) - (int32)lo;
}

/* Directly read BIOS count of time ticks. This is used instead of
 * calling biostime(0,0L). The latter calls BIOS INT 1A, AH=0,
 * which resets the midnight overflow flag, losing days on the clock.
 */
long
bioscnt(void)
{
	long rval;
	int i_state;

	i_state = disable();
	dosmemget(0x46c,sizeof(rval),&rval);
	restore(i_state);
	return rval;
}

/* Atomic read-and-decrement operation.
 * Read the variable pointed to by p. If it is
 * non-zero, decrement it. Return the original value.
 */
int
arddec(p)
volatile int *p;
{
	int tmp;
	int i_state;

	i_state = disable();
	tmp = *p;
	if(tmp != 0)
		(*p)--;
	restore(i_state);
	return tmp;
}
void
restore(int state)
{
	state ? enable() : disable();
}
int
istate(void)
{
  long flags;
  asm ("pushfl\n\t"		/* We save the old ccr, which has interrupt mask bit. */
       "popl %0\n\t" : "=r" (flags));
  return (flags >> 9) & 1;
}

/* This function is called by exit() in the GCC libc. We define
 * it here to supersede the one defined in libc's stdio
 */
void
_cleanup(void)
{
	fcloseall();
}

/* clockbits - Read low order bits of timer 0 (the TOD clock)
 * This works only for the 8254 chips used in ATs and 386s.
 *
 * The timer runs in mode 3 (square wave mode), counting down
 * by twos, twice for each cycle. So it is necessary to read back the
 * OUTPUT pin to see which half of the cycle we're in. I.e., the OUTPUT
 * pin forms the most significant bit of the count. Unfortunately,
 * the 8253 in the PC/XT lacks a command to read the OUTPUT pin...
 *
 * The PC's clock design is soooo brain damaged...
 */
int16
clockbits(void)
{
	int i_state;
	unsigned int stat,count;

	do {
		i_state = disable();
		outportb(0x43,0xc2);	/* latch timer 0 count and status for reading */
		stat = inportb(0x40);	/* get status of timer 0 */
		count = inportb(0x40);	/* lsb of count */
		count |= inportb(0x40) << 8;	/* msb of count */
		restore(i_state);	/* no more chip references */
	} while(stat & 0x40);		/* reread if NULL COUNT bit set */
	stat = (stat & 0x80) << 8;	/* Shift OUTPUT to msb of 16-bit word */
	count >>= 1;			/* count /= 2 */
	if(count == 0)
		return stat ^ 0x8000;	/* return complement of OUTPUT bit */
	else
		return count | stat;	/* Combine OUTPUT with counter */
}

void
kbint(void)
{
	psignal(&kbint,1);
}

void
giveup(void)
{
}
void
sysreset(void)
{
}

int16
lcsum(int16 *buf,int16 cnt)
{
	uint32 sum = 0;

	while(cnt-- != 0)
		sum += *buf++;
	while(sum > 65535)
		sum = (sum & 0xffff) + (sum >> 16);
	return ((sum >> 8) | (sum << 8)) & 0xffff;
}

/* What a crock. All this inelegance should be replaced with something
 * that figures out what interrupt is being serviced by reading the 8259.
 */
static void irq0(void)
{
	eoi();
	(*Int_tab[0].func)(Int_tab[0].arg);
}
static void irq1(void)
{
	eoi();
	(*Int_tab[1].func)(Int_tab[1].arg);
}
static void irq2(void)
{
	eoi();
	(*Int_tab[2].func)(Int_tab[2].arg);
}
static void irq3(void)
{
	eoi();
	(*Int_tab[3].func)(Int_tab[3].arg);
}
int Irq4s;
static void irq4(void)
{
	disable();
	Irq4s++;
	eoi();
	(*Int_tab[4].func)(Int_tab[4].arg);
	enable();
}
static void irq5(void)
{
	eoi();
	(*Int_tab[5].func)(Int_tab[5].arg);
}
static void irq6(void)
{
	eoi();
	(*Int_tab[6].func)(Int_tab[6].arg);
}
static void irq7(void)
{
	eoi();
	(*Int_tab[7].func)(Int_tab[7].arg);
}
static void irq8(void)
{
	eoi();
	(*Int_tab[8].func)(Int_tab[8].arg);
}
static void irq9(void)
{
	eoi();
	(*Int_tab[9].func)(Int_tab[9].arg);
}
static void irq10(void)
{
	eoi();
	(*Int_tab[10].func)(Int_tab[10].arg);
}
static void irq11(void)
{
	eoi();
	(*Int_tab[11].func)(Int_tab[11].arg);
}
static void irq12(void)
{
	eoi();
	(*Int_tab[12].func)(Int_tab[12].arg);
}
static void irq13(void)
{
	eoi();
	(*Int_tab[13].func)(Int_tab[13].arg);
}
static void irq14(void)
{
	eoi();
	(*Int_tab[14].func)(Int_tab[14].arg);
}
static void irq15(void)
{
	eoi();
	(*Int_tab[15].func)(Int_tab[15].arg);
}

static void (*Vectab[16])(void) = {
	irq0,irq1,irq2,irq3,irq4,irq5,irq6,irq7,irq8,irq9,irq10,irq11,
	irq12,irq13,irq14,irq15
};

int
setvect(uint irq, int chain, void (*func)(int),int arg)
{
	struct int_tab *ip;
	uint intno;
	int i;

	if(irq > 15)
		return -1;	/* IRQ out of legal range */

	ip = &Int_tab[irq];
	if(ip->func != NULL)
		return -1;	/* Already in use */
	/* Convert irq to actual CPU interrupt vector */
	intno = (irq < 8) ? irq + 8 : 0x70 + irq - 8;

	__dpmi_get_protected_mode_interrupt_vector(intno,&ip->old);
	ip->func = func;
	ip->arg = arg;
	ip->new.pm_offset = (int)Vectab[irq];
	ip->new.pm_selector = _go32_my_cs();
	ip->chain = chain;

	if(chain)
		return _go32_dpmi_chain_protected_mode_interrupt_vector(intno,&ip->new);

	if(i =_go32_dpmi_allocate_iret_wrapper(&ip->new))
		return i;
	return _go32_dpmi_set_protected_mode_interrupt_vector(intno,&ip->new);
}

int
freevect(uint irq)
{
	struct int_tab *ip;
	int i;

	if(irq > 15)
		return -1;	/* IRQ out of legal range */

	ip = &Int_tab[irq];
	ip->func = NULL;
	/* Convert irq to actual CPU interrupt vector */
	irq = (irq < 8) ? irq + 8 : 0x70 + irq - 8;
	if(ip->chain)
		return _go32_dpmi_unchain_protected_mode_interrupt_vector(irq,&ip->new);
	if(i = __dpmi_set_protected_mode_interrupt_vector(irq,&ip->old))
		return i;
	return _go32_dpmi_free_iret_wrapper(&ip->new);
}
/* Re-arm 8259 interrupt controller(s)
 * Should be called just after taking an interrupt, instead of just
 * before returning. This is because the 8259 inputs are edge triggered, and
 * new interrupts arriving during an interrupt service routine might be missed.
 */
void
eoi(void)
{
	/* read in-service register from secondary 8259 */
	outportb(0xa0,0x0b);
	if(inportb(0xa0))
		outportb(0xa0,0x20);	/* Send EOI to secondary 8259 */
	outportb(0x20,0x20);	/* Send EOI to primary 8259 */
}


char Hashtab[256];

int16
hash_ip(ipaddr)
uint32 ipaddr;
{
int h;

	h = ((ipaddr >> 16) & 0xFFFF) ^ (ipaddr & 0xFFFF);
	return Hashtab[((h >> 8) & 0xFF) ^ (h & 0xFF)];
}


int
dirps ()
{
	return disable ();
}

/* Convert a pointer to a long integer */
long
ptol(p)
void *p;
{
	long x;

	x = FP_OFF(p);
#ifdef	LARGEDATA
	x |= (long)FP_SEG(p) << 16;
#endif
	return x;
}
void *
ltop(l)
long l;
{
	register unsigned seg,offset;

	seg = l >> 16;
	offset = l;
	return MK_FP(seg,offset);
}

void
strrev (char *str)
{
char *cp, *save, *cp2;

	save = malloc (strlen (str) + 1);
	cp2 = str;
	cp = &save[strlen(str)];
	*cp-- = 0;
	while (*cp2)
		*cp-- = *cp2++;
	strcpy (str, save);
	free (save);
}

long
dostounix(dp, tp)
struct date *dp;
struct time *tp;
{
static struct tm tm;
struct tm *tx;
time_t now;

	tm.tm_year = dp->da_year - 1900;
	tm.tm_mon = dp->da_mon - 1;
	tm.tm_mday = dp->da_day;
	tm.tm_hour = tp->ti_hour;
	tm.tm_min = tp->ti_min;
	tm.tm_sec = tp->ti_sec;
	/* This desperately needs to be fixed.  How? */
	time (&now);
	tx = localtime (&now);
	tm.tm_isdst = tx->tm_isdst;
	return mktime (&tm);
}


void
fcloseall (void)
{
}

#undef free

/* Written to extend gopint.c in djgpp library */
int
_go32_dpmi_unchain_protected_mode_interrupt_vector(uint irq,_go32_dpmi_seginfo *info)
{
  __dpmi_paddr v;
  char *stack;
  char *wrapper;

  __dpmi_get_protected_mode_interrupt_vector(irq,&v);
  /* Sanity check: does the vector point into our program? A bug in gdb
   * keeps us from hooking the keyboard interrupt when we run under its
   * control. This test catches it.
   */
  if(v.selector != _go32_my_cs())
	return -1;
  wrapper = (char *)v.offset32;
  /* Extract previous vector from the wrapper chainback area */
  v.offset32 = *(long *)(wrapper + 0x5b);
  v.selector = *(short *)(wrapper + 0x5f);
  /* Extract stack base from address of _call_count variable in wrapper */
  stack = (char *)(*(long *)(wrapper+0x0F) - 8);
#define	STACK_WAS_MALLOCED	(1 << 0)

  if (*(long *) stack & STACK_WAS_MALLOCED)
      free(stack);
  free(wrapper);
  __dpmi_set_protected_mode_interrupt_vector(irq,&v);
  return 0;
}


#endif /* MSDOS */
